#include <Array.au3>
;~ _GetSoftwareVersion_DisplayIni()

$sVersion = _GetSoftwareVersion('firefox')
ConsoleWrite('Error: ' & @error & @CR)
MsgBox(0, 'Version', $sVersion)

Func _GetSoftwareVersion($sSoftware)
	Local $sRegKey, $sVersion, $sInifile, $sTmp, $aSoftware
	$sInifile = @ScriptDir & '\_GetSoftwareVersion.ini'
	If @OSArch = 'X86' Then
		$sRegKey = 'HKEY_LOCAL_MACHINE\SOFTWARE\'
	Else
		$sRegKey = 'HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\'
	EndIf
	$aSoftware = IniReadSectionNames($sInifile)
	If @error Then Return SetError(1, 0, 'no Inifile')
	For $i = 1 To $aSoftware[0]
		If $aSoftware[$i] = $sSoftware Then
			$sRegKey &= IniRead($sInifile, $aSoftware[$i], 'RegKey', '')
			$sTmp = IniRead($sInifile, $aSoftware[$i], 'Version', '')
			If StringLeft($sTmp, 3) = 'Reg' Then $sVersion = Execute($sTmp)
			Return $sVersion
		EndIf
	Next
	Return SetError(2, 0, 'not found')
EndFunc

Func _GetSoftwareVersion_DisplayIni()
	Local $sInifile, $aSoftware
	$sInifile = @ScriptDir & '\_GetSoftwareVersion.ini'
	$aSoftware = IniReadSectionNames($sInifile)
	If @error Then Return SetError(1, 0, 'no Inifile')
	Local $aRegKey[$aSoftware[0] + 1][3] = [[$aSoftware[0], 0, 0]]
	For $i = 1 To $aSoftware[0]
		$aRegKey[$i][0] = $aSoftware[$i]
		$aRegKey[$i][1] = IniRead($sInifile, $aSoftware[$i], 'RegKey', '')
		$aRegKey[$i][2] = IniRead($sInifile, $aSoftware[$i], 'Version', '')
	Next
	_ArrayDisplay($aRegKey)
EndFunc
